#include <string>
#include <algorithm>
#include <list>
#include <iostream>
using namespace std;
 
// filename stllist1.cpp

void main ()
{
	list<int> li;  // create an empty vector of integers

	cout << "Size = " << li.size() << endl;
//	cout << "Capacity = " << li.capacity() << endl;
	
	int input;
	while (cin >> input)    // while not end of file
	{
		li.push_back (input);  // append to vector
	}

	cout << "Size = " << li.size() << endl;

	cout << "List contents:" << endl;
	int n = li.size();
	list<int>::const_iterator it;
	for( it = li.begin(); it != li.end(); it++)
	{
		// Notice deferencing of the iterator using *
		cout << *it << "\n";
	}

	cout << "Delete all 42's from the list" << endl;
	li.remove(42);

	cout << "Size = " << li.size() << endl;

	cout << "List contents" << endl;
	for(it = li.begin(); it != li.end(); it++)
	{
		cout << *it << "\n";
	}

	cout << "First value in list = " << li.front() << endl;
	cout << "Last value in list = " << li.back() << endl;

	cout << "Process list" << endl;
	while(li.size() > 0)
	{
		cout << 2 * li.front() << endl;
		li.pop_front();
	}
	cout << "End of list" << endl;
}

